image: docker:latest

services:
  - docker:dind

variables:
  DOCKER_HOST: tcp://docker:2376
  DOCKER_TLS_CERTDIR: "/certs"

release-notes:
  image: alpine
  stage: deploy
  script:
    - |
      apk add --no-cache jq curl git uuidgen
      apk add --virtual build_deps gettext
      echo "Extracting release notes for pid $CI_PROJECT_ID:$CI_COMMIT_REF_NAME"
      export RELEASE_NOTES=`curl --fail -XGET -H "private-token: $GITLAB_TOKEN" https://gitlab.com/api/v4/projects/$CI_PROJECT_ID/repository/tags/$CI_COMMIT_REF_NAME | jq -r '.release.description'`
      export RELEASE_LEAD=`curl --fail -XGET -H "private-token: $GITLAB_TOKEN" https://gitlab.com/api/v4/projects/$CI_PROJECT_ID/repository/tags/$CI_COMMIT_REF_NAME | jq -r '.message'`
      [ "$RELEASE_NOTES" == "" ] && exit 0
      export SLUG=`printf "flow-ui-backend-%s" $CI_COMMIT_REF_NAME`
      export UUID=`uuidgen`
      export BRANCH_NAME="release-notes/$UUID"
      git clone https://token:$WIKI_TOKEN@gitlab.com/bizztreat/bizzflow/r2/wiki.git /tmp/wiki
      mkdir -p "/tmp/wiki/content/release-notes/$SLUG"
      cat /tmp/wiki/release-notes.template | envsubst > "/tmp/wiki/content/release-notes/$SLUG/index.md"
      cd /tmp/wiki
      git config --global user.email "connect@bizztreat.com"
      git config --global user.name "Builder Service Account"
      git checkout -b "$BRANCH_NAME"
      git add .
      git commit -m "release notes: $SLUG"
      git push origin "$BRANCH_NAME"
      curl -XPOST \
          --fail \
          -H "private-token: $WIKI_TOKEN" \
          -H "Content-type: application/json" \
          -d '{"id": 19126419, "title": "auto release notes '"$SLUG"'", "remove_source_branch": true, "source_branch": "'"$BRANCH_NAME"'", "target_branch": "master", "assignee_ids": [7353833, 3262908], "reviewer_ids": [7353833, 3262908]}' \
          https://gitlab.com/api/v4/projects/19126419/merge_requests
  only:
    - tags

build:
  stage: build
  script:
    - docker info
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker build . --tag $CI_REGISTRY_IMAGE:${CI_COMMIT_REF_NAME//\//\-} --build-arg VERSION=$CI_COMMIT_REF_NAME --build-arg GIT_SHA=$CI_COMMIT_SHA
    - docker push $CI_REGISTRY_IMAGE:${CI_COMMIT_REF_NAME//\//\-}
  only:
    - tags
    - merge_requests

build-master:
  stage: build
  script:
    - docker info
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker build . --tag $CI_REGISTRY_IMAGE:latest
    - docker push $CI_REGISTRY_IMAGE:latest
  only:
    - master
